/**
 * Statement that runs the garbage collector
 *
 * @author Kuba Madej
 *
 */
public class CollectStatement implements Statement {
	/**
	 * Garbage collector to run
	 */
	private Collector collector;

	/**
	 * Heap to work on
	 */
	private int[] heap;

	/**
	 * Constructs new instance
	 *
	 * @param heap
	 *            heap to work on
	 * @param collector
	 *            garbage collector to run during execution of this statement
	 */
	public CollectStatement(int[] heap, Collector collector) {
		this.heap = heap;
		this.collector = collector;
	}

	/**
	 *
	 *
	 * @see Statement#execute()
	 */
	public void execute() {
		NPJ.collect(heap, collector);
	}

}
