/**
 * An example implementation of NPJ class
 *
 * @author Kuba Madej
 *
 */
public class NPJ {
	/**
	 * Prints the given string
	 *
	 * @param string
	 *            string to print
	 */
	public static void print(String string) {
		System.out.println("Print: " + string);
	}

	/**
	 * Analyzes heap passed as an argument
	 *
	 * @param heap
	 *            heap to analyze
	 */
	public static void heapAnalyze(int[] heap) {
		System.out.print("HeapAnalyze:   ");
		toString(heap);
	}

	private static void toString(int[] heap) {
		for (int i = 1; i <= heap.length / 2; i++)
			System.out.printf("%2d ", heap[i]);
		System.out.println();
		System.out.print("               ");
		for (int i = (heap.length) / 2 + 1; i < heap.length; i++)
			System.out.printf("%2d ", heap[i]);
		System.out.println();
	}

	/**
	 * Runs garbage collector
	 *
	 * @param heap
	 *            heap to collect garbage from
	 * @param collector
	 *            garbage collector to run
	 */
	public static void collect(int[] heap, Collector collector) {
		System.out.print("BeforeCollect: ");
		toString(heap);
		collector.collect(heap);
		System.out.print("AfterCollect:  ");
		toString(heap);
	}
}
